<!DOCTYPE html>
<html>

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container">
    <h2>Registration Car Form</h2>

    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-fname">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-lname">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="country-select">Country</label>
        </div>
        <div class="col-sm-3">
          <select id="country-select" name="country" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="region-type-select">Region</label>
        </div>
        <div class="col-sm-3">
          <select id="region-type-select" name="region" class="form-control">
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="car-select">Car</label>
        </div>
        <div class="col-sm-3">
          <select id="car-select" name="car" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="car-type-select">Car type</label>
        </div>
        <div class="col-sm-3">
          <select id="car-type-select" name="car-type" disabled class="form-control">
          </select>
        </div>
      </div>
      <div class="row">
        <div class="col-sm-12" style="text-align: right;">
          <button class="btn btn-info" id="btn-send"> Send </button>
        </div>
      </div>
    </div>
  </div>
</body>

<script>
  "use strict";
  $(document).ready(function () {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // car brand information
    var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;

    // country information
    var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;

    var gObjectCarData = JSON.parse(gJsonCarData);

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    $("#car-select").on("change", function(){
      onSelectChange(this);
    })
    $("#btn-send").on("click",function(){
      onBtnSendClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      "use strict";
      fillDataToCarSelect();
    }
    // Hàm xử lý khi click nút Send
    function onBtnSendClick(){
      "use strict";
      var vBrandId = $("#car-select").val();
      var vBrandName = $("#car-select option:selected").text();
      var vTypeId = $("#car-type-select").val();
      var vTypeName = $("#car-type-select option:selected").text();
      console.log(`Ta có BrandId: ${vBrandId}`);
      console.log(`Ta có BrandName: ${vBrandName}`);
      console.log(`Ta có TypeId: ${vTypeId}`);
      console.log(`Ta có TypeName: ${vTypeName}`);
    }
    // Hàm xử lý khi change select Car
    function onSelectChange(paramSelect){
      "use strict";
      var vBrandId = $(paramSelect).val();
      console.log(`BrandId vừa chọn là ${vBrandId}`);
      var vListBrandType = getBrandTypeByBrandID(vBrandId);
      console.log(vListBrandType);
      $('#car-type-select').empty();// Làm rỗng dữ liệu
      $('#car-type-select').removeAttr("disabled");
      if(vListBrandType.length > 0){        
        for (var bI = 0; bI < vListBrandType.length; bI++) {
          $('#car-type-select').append($('<option>', {
            value: vListBrandType[bI].typeId,
            text: vListBrandType[bI].typeName
          }));
        }
      }else{
        $('#car-type-select').attr("disabled", "disabled");
      }
      
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm đổ dữ liệu vào ô Select Car
    function fillDataToCarSelect() {
      "use strict";
      console.log(gObjectCarData);
      for (var bI = 0; bI < gObjectCarData.length; bI++) {
        $('#car-select').append($('<option>', {
          value: gObjectCarData[bI].brandId,
          text: gObjectCarData[bI].brandName
        }));
      }

    }
    /**
     * get brandType by brandId
     * input: brandId of a car
     * output: brandType name of found car. If not found, it returns null
     */
    function getBrandTypeByBrandID(paramBrandId) {
      var vBrandFound = false;
      var vBrandTypesResult = null;
      var vIterator = 0;
      while (!vBrandFound && vIterator < gObjectCarData.length) {
        if (gObjectCarData[vIterator].brandId === paramBrandId) {
          vBrandFound = true;
          vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
        }
        else {
          vIterator++;
        }
      }
      return vBrandTypesResult;
    }
  })
</script>

</html>